import { dirname, resolve } from "node:path";
import { fileURLToPath } from "node:url";
import { log } from "node:console";
import { clsx } from "clsx";
import jsonLoose from "json-loose";
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal || freeSelf || Function("return this")();
var Symbol$1 = root.Symbol;
var objectProto$1 = Object.prototype;
var hasOwnProperty = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$1 ? Symbol$1.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString(value) {
  return nativeObjectToString.call(value);
}
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$1 ? Symbol$1.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isArray = Array.isArray;
var stringTag = "[object String]";
function isString(value) {
  return typeof value == "string" || !isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
}
function isNil(value) {
  return value == null;
}
function isNull(value) {
  return value === null;
}
function isEnabled(input) {
  return input === true || input === "";
}
function normalizeBreakpointProp(prefix, prop) {
  if (isBooleanLike(prop)) {
    return isTruthy(prop) ? prefix : "";
  }
  prop = typeof prop === "string" || typeof prop === "number" ? String(prop).split(" ") : prop;
  if (Array.isArray(prop)) {
    return prop.map((item) => {
      if (isBooleanLike(item)) {
        return isTruthy(item) ? prefix : "";
      }
      return `${prefix}-${item}`;
    }).join(" ");
  }
  return "";
}
function isBooleanLike(input) {
  return typeof input === "boolean" || ["true", "false"].includes(input);
}
function isTruthy(input) {
  return !!input;
}
function isFalsy(input) {
  return !input;
}
const requiredUtils = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  clsx,
  isBooleanLike,
  isEnabled,
  isFalsy,
  isNil,
  isNull,
  isString,
  isTruthy,
  jsonLoose,
  log,
  normalizeBreakpointProp
}, Symbol.toStringTag, { value: "Module" }));
function defineBootstrapUIConfig(options = {}) {
  const { folders = [], utilities, expressions, ...restOpts } = options;
  const __dirname = dirname(fileURLToPath(import.meta.url));
  folders.push(
    resolve(__dirname, "./ui")
  );
  return {
    // users configs
    ...restOpts,
    // opinionated configs
    root: "",
    tagPrefix: "ui:",
    yield: "children",
    attribute: "@src",
    // hybrid
    folders,
    expressions: {
      missingLocal: null,
      unescapeDelimiters: ["{{~", "~}}"],
      ...expressions
    },
    utilities: { ...requiredUtils, ...utilities }
  };
}
export {
  defineBootstrapUIConfig
};
